<template>
    <div class="app-container">
        <div class="filter-container">
            <el-row :gutter="20">
                <el-col :span="16" ref="filter" :model="filter">
                    <el-input prop="keyword" v-model="filter.keyword" ref="keyword" name="keyword" placeholder="Judul, nama, no telepon" style="width: 300px;" size="medium" class="filter-item" clearable @keyup.enter.native="handleSearch" @clear="handleSearch"/>
                    <el-button @click="handleSearch" size="mini" type="primary" class="filter-item">
                        <i class="ion-ios-search"></i> Cari
                    </el-button>
                </el-col>
                <el-col :span="8" class="text-align-right">
                    <el-button v-permission="[null, 'contact', 'create']" @click="handleCreate" size="mini" type="success">
                        <i class="ion-ios-add-circle"></i> Tambah Kontak
                    </el-button>
                </el-col>
            </el-row>            
        </div>
        <el-table v-loading="tableLoading" :data="contacts" ref="contactTable" style="width: 100%" :height="tableHeight" fit highlight-current-row>
            <el-table-column
                fixed="left"
                label="Judul Kontak"
                width="200">
                <template slot-scope="scope">
                    <span style="color:#3E89FA;">{{ scope.row.title }}</span>
                </template>
            </el-table-column>
            <el-table-column
                label="Nama"
                width="200">
                <template slot-scope="scope">
                    <span>{{ scope.row.fullname }}</span>
                </template>
            </el-table-column>
            <el-table-column
                label="Alamat"
                width="300">
                <template slot-scope="scope">
                    <span>{{ scope.row.address }}</span>
                </template>
            </el-table-column>
            <el-table-column
                label="No. Telp 1"
                width="150">
                <template slot-scope="scope">
                    <span>{{ scope.row.phone }}</span>
                </template>
            </el-table-column>
            <el-table-column
                label="No. Telp 2"
                width="150">
                <template slot-scope="scope">
                    <span>{{ scope.row.alt_phone }}</span>
                </template>
            </el-table-column>
            <el-table-column
                label="Email"
                width="150">
                <template slot-scope="scope">
                    <span>{{ scope.row.email }}</span>
                </template>
            </el-table-column>
            <el-table-column
                label="Deskripsi"
                width="300">
                <template slot-scope="scope">
                    <span>{{ scope.row.description }}</span>
                </template>
            </el-table-column> 
            <el-table-column
                label="Terakhir Diubah"
                width="150">
                <template slot-scope="scope">
                    {{ dateFormat(scope.row.updated) }}
                </template>
            </el-table-column>
            <el-table-column
                fixed="right"
                label="Tindakan"
                min-width="200">
                <template slot-scope="{row}">
                    <el-button v-permission="[row, 'contact', 'viewother']" type="text" @click="handleEdit(row)">Ubah</el-button>
                    <el-button v-permission="[row, 'contact', 'deleteother']" type="text" class="text-danger" @click="handleDelete(row)">Hapus</el-button>
                </template>
            </el-table-column>
        </el-table>
        
        <pagination v-show="pagination.pages>1" :total="pagination.total" :page.sync="pagination.page" :perpage.sync="pagination.perpage" @pagination="handleSearch" />

        <el-dialog v-loading="dialogLoading" :title="dialogTitle[dialogStatus]" :visible.sync="showDialog" width="40%" :show-close="false" @closed="resetForm">
            <el-form ref="contactForm" :model="contactForm" :rules="contactRules">
                <aside>
                    <el-alert type="info" description="Mengatur daftar semua kontak penting yang ada di Indonesia yang akan digunakan oleh seluruh pengguna." :closable=false show-icon></el-alert>
                </aside>
                <el-row :gutter="20">
                    <el-col :lg="14" :md="24" :xs="24">
                        <el-form-item label="Judul" prop="title">
                            <el-input ref="title" name="title" v-model="contactForm.title" placeholder="Judul kontak" autocomplete="off" maxlength="255" show-word-limit></el-input>
                        </el-form-item>
                    </el-col>
                    <el-col :lg="10" :md="24" :xs="24">
                        <el-form-item label="Nama Lengkap" prop="fullname">
                            <el-input ref="fullname" name="fullname" v-model="contactForm.fullname" placeholder="Nama lengkap" autocomplete="off" maxlength="255" show-word-limit></el-input>
                        </el-form-item>
                    </el-col>
                </el-row>
                <el-row :gutter="20">
                    <el-col :lg="16" :md="24" :xs="24">
                        <el-form-item label="Alamat" prop="address">
                            <el-input ref="address" name="address" v-model="contactForm.address" placeholder="Alamat kontak" autocomplete="off" maxlength="255" show-word-limit></el-input>
                        </el-form-item>
                    </el-col>
                    <el-col :lg="8" :md="24" :xs="24">
                        <el-form-item label="Kode Pos" prop="region">
                            <el-select
                                ref="region"
                                name="region"
                                class="width-100"
                                clearable
                                filterable
                                remote
                                :remote-method="getRegions"
                                v-model="contactForm.region"
                                value-key="id"
                                placeholder="Ketik kode pos"
                                no-data-text="No Data"
                                :loading="regionLoading">
                                <el-option
                                    v-for="item in regions"
                                    :key="item.id"
                                    :label="item.name+' ('+item.postal+')'"
                                    :value="item.id">     
                                    <span style="float: left">{{ item.name }}</span>
                                    <strong style="float: right; color: #8492a6; font-size: 13px">{{ getAdministrative(item) }}</strong>                   
                                </el-option>
                            </el-select>
                        </el-form-item>
                    </el-col>
                </el-row>                
                <el-row :gutter="20">
                    <el-col :lg="12" :md="24" :xs="24">
                        <el-form-item label="No. Telp 1" prop="phone">
                            <el-input type="number" ref="phone" name="phone" v-model="contactForm.phone" placeholder="No. telp aktif" autocomplete="off" maxlength="45"></el-input>
                        </el-form-item>
                    </el-col>
                    <el-col :lg="12" :md="24" :xs="24">
                        <el-form-item label="No. Telp 2" prop="alt_phone">
                            <el-input type="number" ref="alt_phone" name="alt_phone" v-model="contactForm.alt_phone" placeholder="No. telp aktif" autocomplete="off" maxlength="255"></el-input>
                        </el-form-item>
                    </el-col>
                </el-row>
                <el-row :gutter="20">
                    <el-col :lg="10" :md="24" :xs="24">
                        <el-form-item label="Email" prop="email">
                            <el-input ref="email" name="email" v-model="contactForm.email" placeholder="Alamat email actif" autocomplete="off" maxlength="45" show-word-limit></el-input>
                        </el-form-item>
                    </el-col>
                    <el-col :lg="14" :md="24" :xs="24">
                        <el-form-item label="Deskripsi" prop="description">
                            <el-input ref="description" name="description" v-model="contactForm.description" placeholder="Deskripsi kontak" autocomplete="off" maxlength="255" show-word-limit></el-input>
                        </el-form-item>
                    </el-col>
                </el-row>
            </el-form>
            <span slot="footer" class="dialog-footer">
                <el-button @click="showDialog = false" size="medium">Batal</el-button>
                <el-button v-permission="[null, 'contact', 'editown']" @click="handleSubmit" size="mini" type="success">
                    <i class="ion-ios-checkmark-circle"></i> {{ dialogTitle[dialogStatus] }}
                </el-button>
            </span>
        </el-dialog>

    </div>
</template>
<script>
import { mapGetters } from 'vuex';
import permission from '@/directive/permission/index.js';
import Pagination from '@/components/Pagination';
import { parseError, playSound, dateFormat, tableHeight } from '@/utils/index';

export default {
    name: 'Contact',
    components: {
        Pagination
    },
    directives: {
        permission
    },
    data(){

        var validateEmail = (rule, value, callback) => {
            if(value.trim().length > 0 && !/^[a-zA-Z0-9_.+-]+@[a-zA-Z0-9-]+\.[a-zA-Z0-9-.]+$/.test(value)){
                return callback(new Error('Alamat email tidak valid.'))
            }
            callback();
        };

        return {
            tableLoading: false,
            dialogLoading: false,
            regionLoading: false,
            filter: {
                keyword: ''
            },
            showDialog: false,
            dialogStatus: '',
            dialogTitle: {
                edit: 'Ubah Kontak',
                create: 'Tambah Kontak'
            },
            contactForm: {
                id: null,
                title: '',
                fullname: '',
                address: '',
                phone: '',
                alt_phone: '',
                email: '',
                description: '',
                region: null,
                latitude: null,
                longitude: null,
                archived: false
            },
            contactRules: {
                title: [{ 
                    required: true, message: 'Judul kontak wajib diisi', trigger: 'blur'
                }, {
                    max: 255, message: 'Panjang judul kontak maksimal 255 karakter', trigger: 'blur'
                }, {
                    pattern: /^([a-zA-Z0-9-()&\s/+.,]{1,255})$/, message: 'Hanya huruf, angka, tanda minus, tanda kurung, ampersand, garis miring, tanda plus, titik, koma dan spasi yang diperbolehkan', trigger: 'blur'
                }],
                fullname: [{ 
                    required: true, message: 'Nama lengkap wajib diisi', trigger: 'blur'
                }, {
                    max: 255, message: 'Panjang nama lengkap maksimal 255 karakter', trigger: 'blur'
                }, {
                    pattern: /^([a-zA-Z0-9-()&\s/+.,]{1,255})$/, message: 'Hanya huruf, angka, tanda minus, tanda kurung, ampersand, garis miring, tanda plus, titik, koma dan spasi yang diperbolehkan', trigger: 'blur'
                }],
                phone: [{
                    required: true, message: 'No. telepon wajib diisi.', trigger: 'blur'
                }],
                address: [{ 
                    required: true, message: 'Alamat wajib diisi', trigger: 'blur'
                }, {
                    max: 255, message: 'Panjang Alamat maksimal 255 karakter', trigger: 'blur'
                }],
                email: [{
                    max: 45, message: 'Panjang Alamat maksimal 255 karakter', trigger: 'blur'
                }, {
                    validator: validateEmail, trigger: 'blur'
                }],
                description: [{ max: 255, message: 'Panjang deskripsi maksimal 255 karakter', trigger: 'blur'}]
            },
        };
    },
    computed: {
        tableHeight,
        ...mapGetters('user', ['me']),
        ...mapGetters('region', ['regions']),
        ...mapGetters('contact', [
            'contacts',
            'pagination'
        ]),
    },
    created() {
        this.getContacts();
    },
    methods: {
        playSound,
        dateFormat,
        isNumeric(n) {
            return !isNaN(parseFloat(n)) && isFinite(n);
        },
        getAdministrative(region, level){
            var temp = [];
            level = level || 0;

            if(region.parents){
                temp.push(region.name);
                level++;
                temp.push.apply(temp, this.getAdministrative(region.parents, level));
            }else{
                temp.push(region.name);
            }

            if(temp.length == 4){
                temp.splice(0,2);
                return temp.join(', ');
            }
            
            return temp;
        },
        getContacts() {
            this.tableLoading = true;
            this.$store.dispatch('contact/getContacts', {
                page: this.pagination.page,
                perpage: this.pagination.perpage
            }).then(() => {
                this.tableLoading = false;
            });
        },
        getRegions(q) {
            if(q.length >= 3 && this.isNumeric(q)){
                this.regionLoading = true;
                this.$store.dispatch('region/getRegions', {
                    q: q,
                    page: this.pagination.page,
                    perpage: this.pagination.perpage
                }).then(() => {
                    this.regionLoading = false;
                });
            }
        },
        handleSearch(){
            this.tableLoading = true;
            this.$store.dispatch('contact/getContacts', {
                q: this.filter.keyword,
                page: this.pagination.page,
                perpage: this.pagination.perpage
            }).then(() => {
                this.tableLoading = false;
            });
        },
        handleCreate(){
            this.dialogStatus = 'create';
            this.showDialog = true;          
            this.$nextTick(() => {
                this.$refs['contactForm'].clearValidate();
            });
        },
        handleEdit(contact){
            this.dialogStatus = 'edit';
            this.showDialog = true;   
            this.contactForm.id = contact.id;
            this.contactForm.title = contact.title;
            this.contactForm.fullname = contact.fullname;
            this.contactForm.address = contact.address;
            this.contactForm.region = contact.region.id;
            this.contactForm.phone = contact.phone;
            this.contactForm.alt_phone = contact.alt_phone;
            this.contactForm.email = contact.email;
            this.contactForm.description = contact.description;  
            this.contactForm.archived = contact.archived;
            this.getRegions(contact.region.postal);

            this.$nextTick(() => {
                this.$refs['contactForm'].clearValidate()
            });     
        },
        handleSubmit(){
            this.$refs.contactForm.validate((valid) => {
                if(valid){

                    let action = '';
                    let payload = {};

                    this.dialogLoading = true;

                    if(this.dialogStatus == 'create'){
                        action = 'contact/addContact';
                        payload = {
                            title: this.contactForm.title,
                            fullname: this.contactForm.fullname,
                            address: this.contactForm.address,
                            region: this.contactForm.region,
                            phone: this.contactForm.phone,
                            alt_phone: this.contactForm.alt_phone,
                            email: this.contactForm.email,
                            description: this.contactForm.description,
                            archived: this.contactForm.archived
                        };
                    }else if(this.dialogStatus == 'edit'){
                        action = 'contact/editContact';
                        payload = {
                            id: this.contactForm.id,
                            title: this.contactForm.title,
                            fullname: this.contactForm.fullname,
                            address: this.contactForm.address,
                            region: this.contactForm.region,
                            phone: this.contactForm.phone,
                            alt_phone: this.contactForm.alt_phone,
                            email: this.contactForm.email,
                            description: this.contactForm.description,
                            archived: this.contactForm.archived
                        };
                    }

                    this.$store.dispatch(action, payload).then((response) => {
                        this.dialogLoading = false;

                        if('errors' in response){
                            let error = parseError(response.errors);
                            this.$message.error({
                                message: error.messages
                            });
                        }else{
                            this.showDialog = false;
                            this.$message.success({
                                message: response.message
                            });
                            this.resetForm();
                        }

                        this.playSound();

                    });

                }else{
                    return false;
                }
            });
        },
        handleDelete(contact){
            this.$confirm('Anda mencoba untuk menghapus data kontak, data tidak bisa dikembalikan setelah dihapus. Anda yakin?', 'Peringatan', {
                confirmButtonText: 'Ya, Hapus',
                cancelButtonText: 'Batal'
            }).then(() => {
                this.tableLoading = true;
                this.$store.dispatch('contact/deleteContact', {
                    id: contact.id
                }).then((response) => {
                    this.tableLoading = false;
                    if('errors' in response){
                        let error = parseError(response.errors);
                        this.$message.error({
                            message: error.messages
                        });
                    }else{
                        this.showDialog = false;
                        this.$message.success({
                            message: response.message
                        });
                    }

                    this.playSound();
                });
            });
        },
        resetForm() {
            this.contactForm = {
                id: null,
                title: '',
                fullname: '',
                address: '',
                phone: '',
                alt_phone: '',
                email: '',
                description: '',
                region: null,
                latitude: null,
                longitude: null,
                archived: false
            }
        }
    }

}
</script>
